red = pge.gfx.createcolor(255, 0, 0)
green = pge.gfx.createcolor(0, 25, 0)
gray = pge.gfx.createcolor(150, 150, 150)
white = pge.gfx.createcolor(255, 255, 255)
green1 = pge.gfx.createcolor(0, 114, 54)
yellow = pge.gfx.createcolor(200, 200, 0)

impact = pge.font.load("impact.ttf", 20, PGE_RAM)
verdana = pge.font.load("verdana.ttf", 14, PGE_RAM)
verdanas = pge.font.load("verdana.ttf", 10, PGE_RAM)

if not impact then
	error("Failed to load font: impact.ttf")
end

texture1 = pge.texture.load("but1.png", PGE_RAM)
texture2 = pge.texture.load("green1.png", PGE_RAM)
texture3 = pge.texture.load("blue1.png", PGE_RAM)
textureU = pge.texture.load("up.png", PGE_RAM)
textureD = pge.texture.load("down.png", PGE_RAM)
textureL = pge.texture.load("left.png", PGE_RAM)
textureR = pge.texture.load("right.png", PGE_RAM)
texturef = pge.texture.load("f.png", PGE_RAM)

if not (texture1 and texture2 and texture3) then
	error("Failed to load textures.")
end
	if not pge.utils.msginit("Select an option", PGE_UTILS_MSG_DIALOG_YESNO_BUTTONS + PGE_UTILS_MSG_DIALOG_DEFAULT_BUTTON_NO) then
	error("Error on msgdialog init.")
end

x1 = 420
y1 = 10
x0 = x1 + 19
y0 = y1 + 16
i_numbers = 1	-- choosen number
max_numbers = 5
xfield = 10
yfield = 10
sfield = 50
x_cur = 2
y_cur = 3
table_number = 1
table_level = 1
win = 0
xtext = 275
ytext = 70
r = 1
table_names = {"veasy","easy","hard","vhard"}
first = 0

function read_puzzles()
	puzzles = pge.file.open(table_names[table_level], PGE_FILE_RDONLY)
	if not puzzles then
		error("Could not open puzzles file")
	end
	local np = table_number - 1
	if np < 10 then
		pge.file.seek(puzzles, np * 204, PGE_FILE_SET)
	else
		pge.file.seek(puzzles, 1836 + (np - 9) * 205, PGE_FILE_SET)
	end
	local s = pge.file.read(puzzles,4 )
	s = pge.file.read(puzzles,1 )
	while s ~= "a" do s = pge.file.read(puzzles,1 ) end
	pge.file.read(puzzles,6 )
	s = pge.file.read(puzzles,1 )
	if s ~= " " then pge.file.read(puzzles,1 ) end
	pge.file.read(puzzles,3 )
	for k = 1,9 do
		for i = 1, 19 do
			table[k][i] = pge.file.read(puzzles,1)
		end
		if first == 0 then
			for i =20, 24 do
				table[k][i] = "0"
			end
		end
		pge.file.read(puzzles,2)
	end
	puzzles:close()
	savedata()
	first = 0
end

function check_numbers(i)
	if i > max_numbers then i = 1 end
	if i < 1 then i =  max_numbers end
	return i
end

function change_numbers()
	if pge.controls.pressed(PGE_CTRL_RTRIGGER) then i_numbers = check_numbers(i_numbers + 1) end
	if pge.controls.pressed(PGE_CTRL_LTRIGGER) then i_numbers = check_numbers(i_numbers - 1) end
	texture1:activate()
	texture1:draweasy(x1, y1)
	impact:activate()
	impact:print(x0, y0, gray,  i_numbers)
end

function move_cursor()
	if pge.controls.pressed(PGE_CTRL_UP) then y_cur = check_numbers(y_cur - 1) end
	if pge.controls.pressed(PGE_CTRL_DOWN) then y_cur = check_numbers(y_cur + 1) end
	if pge.controls.pressed(PGE_CTRL_LEFT) then x_cur = check_numbers(x_cur - 1) end
	if pge.controls.pressed(PGE_CTRL_RIGHT) then x_cur = check_numbers(x_cur + 1) end
end

function draw_field()
	for x = 1, 5 do
		local x1 = xfield + (x - 1) * sfield
		for y = 1, 5 do
			local y1 = yfield + (y - 1) * sfield
			if x == x_cur and y == y_cur then
				texture3:activate()
				texture3:draweasy(x1, y1)			
			else
				texture2:activate()
				texture2:draweasy(x1, y1)
			end
		end
	end
	if r == -1 then
		local xa = pge.controls.analogx()
		if (xa > 100) and (oldxa < 95) then table_level = table_level + 1 end
		if (xa < -100)  and (oldxa > -95) then table_level = table_level - 1 end
		if table_level > 4 then table_level = 1 end
		if table_level < 1 then table_level = 4 end
		oldxa = xa
		local ya = pge.controls.analogy()
		if (ya > 100) and (oldya < 95) then table_number = table_number - 1 end
		if (ya < -100)  and (oldya > -95) then table_number = table_number + 1 end
		if table_number > 50 then table_number = 1 end
		if table_number < 1 then table_number = 50 end
		oldxa = xa
		oldya = ya
	end
	
	local t = {"Easy!", " Easy", " Hard", "Hard!"}
	for x = 1, 4 do
		local x1 = xtext + (x - 1) * sfield
		if x == table_level then
			texture3:activate()
			texture3:draweasy(x1, ytext)
		else
			texture2:activate()
			texture2:draweasy(x1, ytext)
		end
		verdana:activate()
		if r == 1 then
			verdana:print(x1 + 5, ytext + 20, gray, t[x])
		else
			verdana:print(x1 + 5, ytext + 20, red, t[x])
		end
	end
	
	for x = 1, 5 do
		local x1 = xfield + (x - 1) * sfield
		for y = 1, 5 do
			local y1 = yfield + (y - 1) * sfield
			local s = table[y * 2 - 1][x * 2 - 1]
			if x > 1 then
				local s1 = table[y * 2 - 1][x * 2 - 2]
				if s1 == "<" then
					textureL:activate()
					textureL:draweasy(x1 - 8, y1+16)
				end
				if s1 == ">" then
					textureR:activate()
					textureR:draweasy(x1 - 8, y1 + 16)
				end
			end	
			if y < 5 then
				local s1 = table[y * 2][x * 2 - 1]
				if s1 == "^" then
					textureU:activate()
					textureU:draweasy(x1 + 17, y1 + 43)
				end
				if s1 == "v" then
					textureD:activate()
					textureD:draweasy(x1 + 17, y1 + 43)
				end
			end	
			impact:activate()
			if s ~= "." then 
				impact:print(x1 + 20, y1 + 15, yellow,  s)
			else
				s = table[y * 2 - 1][x + 19]
				if s ~= "0" then
					impact:print(x1 + 20, y1 + 15, gray,  s)
				end
			end

		end
	end
end

function your_turn()
	if pge.controls.pressed(PGE_CTRL_CROSS) then
		table[y_cur * 2 - 1][x_cur + 19] = tostring(i_numbers)
		win = 1
		for y = 1, 5 do
			for x = 1, 5 do
				local s = table[y * 2 - 1][x * 2 + 9]
				local e = table[y * 2 - 1][x * 2 - 1]
				local d = table[y * 2 - 1][x + 19]
				if (s ~= d) and (e ~= s) then
					win = 0
					break
				end
			end
			if win == 0 then break end
		end
		savedata()
	end
	if pge.controls.pressed(PGE_CTRL_TRIANGLE) then
		table[y_cur * 2 - 1][x_cur + 19] = tostring(i_numbers)
		win = 1
		for y = 1, 5 do
			for x = 1, 5 do
				table[y * 2 - 1][x + 19] = table[y * 2 - 1][x * 2 + 9]
			end
		end
		savedata()
	end
	if pge.controls.pressed(PGE_CTRL_SQUARE) then
		table[y_cur * 2 - 1][x_cur + 19] = "0"
		win = 0
		savedata()
	end
	if pge.controls.pressed(PGE_CTRL_SELECT) then
		if r == -1 then read_puzzles() end
		r = -r
		win = 0
	end
	
end

function savedata()
	game_data = tostring(table_number) .. "x" .. tostring(table_level) .. "x" .. tostring(win)
	for y = 1, 5 do
		for x = 1, 5 do
			game_data = game_data .. "x" .. table[y * 2 - 1][x + 19]
		end
	end
	saved = pge.file.open("saved", PGE_FILE_CREATE + PGE_FILE_WRONLY)
	if not saved then
		error("Error opening file saved")
	end
	written = pge.file.write(saved, game_data)
	pge.file.close(saved)
end

function readdata()
	result = pge.file.exists("saved")
	if not result then return end
	saved = pge.file.open("saved", PGE_FILE_RDONLY)
	if not saved then
		pge.file.remove("saved")
		return
	end
	data_size = pge.file.size(saved)
	local b = ""
	local y = 1
	local x = 1
	local i = 0
	for i1= 1,data_size do
		local a = pge.file.read(saved, 1)
		if a ~= "x" then
			b = b .. a
		else
			i = i + 1
			if i == 1 then
				table_number = tonumber(b)
			elseif i == 2 then
				table_level = tonumber(b)
			elseif i == 3 then
				table_win = tonumber(b)
			elseif i > 3 then
				table[y * 2 - 1][x + 19] = b
				x = x + 1
				if x > 5 then
					x = 1
					y = y + 1
				end
			end
			b = ""
		end
	end
	pge.file.close(saved)
	first = 0
end

table = {}
for k = 1, 9 do
	table[k] = {}
	for n = 1, 24 do
		table[k][n] = ""
	end
end

readdata()
read_puzzles()

while pge.running() do
	pge.controls.update()
	pge.gfx.startdrawing()
	if win == 1 then
		pge.gfx.clearscreen(white)
	else
		pge.gfx.clearscreen(green)	
	end

	move_cursor()
	draw_field()
	change_numbers()
	your_turn()
	texturef:activate()
	texturef:draweasy(xtext, 225)
	impact:activate()
	if r ==1 then
		impact:print(xtext + 80, 125, gray, "N "..tostring(table_number))
	else
		impact:print(xtext + 80, 125, red, "N "..tostring(table_number))
	end
	verdana:activate()
	verdana:print(xtext, 10, gray, "Select - ON/OFF")
	verdana:print(xtext, 30, gray, "select puzzle by")
	verdana:print(xtext, 50, gray, "analog joystick")
	verdana:print(xtext, 150, green1, "Rtrigger, Ltrigger - numbers")
	verdana:print(xtext, 170, green1, "Cross - enter number")
	verdana:print(xtext, 190, green1, "Square - erase number")
	verdana:print(xtext, 210, green1, "Triangle - solve puzzle")
	verdanas:activate()
	verdanas:print(xtext+114, 256, gray, "apg4u@mail.ru")

	pge.gfx.enddrawing()
	pge.gfx.swapbuffers()
	if pge.controls.pressed(PGE_CTRL_START) then
		break
	end
end

impact20 = nil